-- Asteroid Spotter Plugin
-- Visit http://web-adventures.org:3000/ for more information
-- Maintained by SlashGordon / Dentek Collector XX-62 in game. For use by WANG guild members only.

-- test cases for API, not for plugin use

dofile("api.lua")

local api = SpotterAPI()

--api.postAsteroid(1, 2, 3, "Carbonic: 92.2 Heliocene: 7.8")
--api.postAsteroid(1, 2, 4, "Pentric: 88.2 Ferric: 11.8")

--api.getAsteroidList(1, 2)

--api.getAsteroidList(2, 2)
	


local sector_roids = {}

api.getAsteroidList(4780, 1, sector_roids)
print(sector_roids[136])

--sector_roids[1] = "Carbonic: 80.0 Heliocene: 20.0 "
--sector_roids[2] = "Carbonic: 92.2 Heliocene: 7.8 "
--sector_roids[3] = "Xithricite: 50.0 Carbonic: 50.0 "
--sector_roids[4] = "Xithricite: 80.0 Heliocene: 20.0 "
--sector_roids[5] = "Heliocene: 40.0 Xithricite: 60.0 "
--sector_roids[6] = "Xithricite: 10.0 Carbonic: 80.0 Denic: 10.0 "
 

function filter_asteroids_ss(ss, criteria)
	local range_roids = {}
	for i,v in pairs(sector_roids) do 
		local sv = string.lower(v)
		if (string.find(sv, ss) ~= nil) then
			if (criteria(i,v)) then                 
				local s,e = string.find(sv, ss)
				local sv0 = string.sub(sv, s)
				s,e = string.find(sv0, ": ")
				s = s + 2
				local sv1 = string.sub(sv0, s)
				local e1, ignore = string.find(sv1, " ")
				local purity = tonumber(string.sub(sv1, 1, e1))
				table.insert(range_roids, {i, purity})
			end
		end
	end
	return range_roids
end

function filter_asteroids(criteria)
	local range_roids = {}
	local index = 1
	for i,v in ipairs(sector_roids) do 
		if (criteria(i,v)) then                    
				table.insert(range_roids, {index, i})
				index = index + 1
		end
	end
	return range_roids
end

function find(ss, targetted)
	local range_roids = filter_asteroids_ss(ss, function(i, v) return i ~= targetted end)

	table.sort(range_roids, function(a,b) 
					return(a[2] > b[2])
					end)

	print(range_roids[1])

	-- find highest
	local all_roids = filter_asteroids_ss(ss, function(i, v) return true end)
	table.sort(all_roids, function(a,b) 
		return(a[2] > b[2])
		end)
	target_id = range_roids[1][1]

	-- find closest_id in radar range
	range_roids = filter_asteroids(function(i, v) return i ~= targetted end)


	table.sort(range_roids, function(a,b)
		local ad = math.abs(target_id - a[1])
		local bd = math.abs(target_id - b[1]) 
		return(ad < bd)
		end)

	print(range_roids[1][1])




end


find("van", 0)